if select(6, GetAddOnInfo("PitBull_" .. (debugstack():match("[i%.][t%.][B%.]ull\\Modules\\(.-)\\") or debugstack():match("[i%.][t%.][B%.]ull\\(.-)\\") or ""))) ~= "MISSING" then return end

local VERSION = tonumber(("$Revision: 39993 $"):match("%d+"))

local PitBull = PitBull
local PitBull_InteractLines = PitBull:NewModule("InteractLines", "AceEvent-2.0", "Parser-3.0")
local self = PitBull_InteractLines
PitBull:SetModuleDefaultState(self, false)
if PitBull.revision < VERSION then
	PitBull.version = "r" .. VERSION
	PitBull.revision = VERSION
	PitBull.date = ("$Date: 2007-06-15 01:38:34 -0400 (Fri, 15 Jun 2007) $"):match("%d%d%d%d%-%d%d%-%d%d")
end
self.desc = "Eye candy that shows lines connecting units that interact with each other."
local remove = table.remove
local UnitIsUnit = UnitIsUnit

local L = PitBull:L("PitBull-InteractLines")

local line_path = "Interface\\AddOns\\" .. debugstack():match("[d%.][d%.][O%.]ns\\(.-)\\[A-Za-z]-%.lua") .. "\\textures\\line"

local tableheap = {}
local function getTable()
	if tableheap[1] then
		local t = tableheap[1]
		remove(tableheap,1)
		return t
	end
	return {}
end
local function scrapTable(t)
	for k in pairs(t) do
		t[k] = nil
	end
	tableheap[#tableheap+1] = t
end

local looselines = {}
local activelines = {}
local function getFrame()
	if looselines[1] then
		local frame = looselines[1]
		activelines[#activelines+1] = frame
		remove(looselines,1)
		return frame
	end
	local frame = UIParent:CreateTexture(nil, "ARTWORK")
	frame:SetTexture(line_path)
	activelines[#activelines + 1] = frame
	return frame
end
local function scrapFrame(index, frame)
	if not frame then
		frame = activelines[index]
	end
	frame:ClearAllPoints()
	frame:Hide()
	
	frame.snd = nil
	frame.rcv = nil
	frame.startalpha = nil
	frame.starttime = nil
	frame.endtime = nil
	frame.type = nil
	
	looselines[#looselines+1] = frame
	remove(activelines,index)
end

local function positionLine(line)
	local ses = line.snd:GetScale()
	local ees = line.rcv:GetScale()
	
	local sx = (line.snd:GetLeft() + line.snd:GetRight()) / 2 * ses
	local sy = (line.snd:GetBottom() + line.snd:GetTop()) / 2 * ses
	local ex = (line.rcv:GetLeft() + line.rcv:GetRight()) / 2 * ees
	local ey = (line.rcv:GetBottom() + line.rcv:GetTop()) / 2 * ees
	
	--[[
	if line.snd.unit == 'targettargettarget' then
		local f = line.snd
		AceLibrary("AceConsole-2.0"):Print("::targettargettarget debug::")
		AceLibrary("AceConsole-2.0"):Print("left:",f:GetLeft())
		AceLibrary("AceConsole-2.0"):Print("right:",f:GetRight())
		AceLibrary("AceConsole-2.0"):Print("top:",f:GetTop())
		AceLibrary("AceConsole-2.0"):Print("bottom:",f:GetBottom())
		
		AceLibrary("AceConsole-2.0"):Print("ses:",f:GetBottom())
		
		AceLibrary("AceConsole-2.0"):Print("sx:",sx)
		AceLibrary("AceConsole-2.0"):Print("sy:",sy)
	end]]
	
	local dx,dy = ex - sx, ey - sy
	local cx,cy = (sx + ex) / 2, (sy + ey) / 2
	if (dx < 0) then
		dx,dy = -dx,-dy
	end
	local length = sqrt(dx^2 + dy^2)
	if length <= 0 then
		return
	end
	local s,c = -dy / length, dx / length
	local sc = s * c
	local Bwid, Bhgt, BLx, BLy, TLx, TLy, TRx, TRy, BRx, BRy;
	if (dy >= 0) then
		Bwid = ((length * c) - (32 * s)) * (32/60)
		Bhgt = ((32 * c) - (length * s)) * (32/60)
		BLx, BLy, BRy = (32 / length) * sc, s^2, (length / 32) * sc
		BRx, TLx, TLy, TRx = 1 - BLy, BLy, 1 - BRy, 1 - BLx
		TRy = BRx
	else
		Bwid = ((length * c) + (32 * s)) * (32/60)
		Bhgt = ((32 * c) + (length * s)) * (32/60)
		BLx, BLy, BRx = s * s, -(length / 32) * sc, 1 + (32 / length) * sc
		BRy, TLx, TLy, TRy = BLx, 1 - BRx, 1 - BLx, 1 - BLy
		TRx = TLy
	end
	local r,g,b
	if line.type == 'h' then
		r,g,b = unpack(self.db.profile.healcolor)
	else
		r,g,b = unpack(self.db.profile.damagecolor)
	end
	line:SetVertexColor(r,g,b,1)
	line:SetTexCoord(TLx, TLy, BLx, BLy, TRx, TRy, BRx, BRy)
	line:SetPoint("TOPRIGHT", UIParent, "BOTTOMLEFT", cx + Bwid, cy + Bhgt)
	line:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", cx - Bwid, cy - Bhgt)
	line:SetAlpha(line.startalpha)
	line:Show()
end

local relationships = setmetatable({},{
	__index = function(t,k)
		local v = getTable()
		t[k] = v
		for unitid, frame in PitBull:IterateUnitFrames() do
			if UnitIsUnit(k,unitid) then
				v[#v+1] = frame
			end
		end
		return v
	end,
})

function PitBull_InteractLines:OnInitialize()
	self.db = PitBull:AcquireDBNamespace("InteractLines")
	PitBull:RegisterDefaults("InteractLines", "profile", {
		alpha = 0.65,
		duration = 3,
		healcolor = { 0.1, 1, 0.1 },
		damagecolor = { 1, 0.1, 0.1 },
		threshold = 300,
		groups = {
			['*'] = {},
		}
	})
end



function PitBull_InteractLines:OnEnable()
	self:RegisterParserEvent({eventType = "Heal"}, self.OnHeal, self)
	self:RegisterParserEvent({eventType = "Damage"}, self.OnDamage, self)
	self:ScheduleRepeatingEvent("PitBullInteractLines-UpdateLines", self.UpdateLines, 0.15, self)
end

do
	local temp = {}
	function PitBull_InteractLines:OnHeal(info)
		if not info.sourceID and not info.recipientID then
			return
		end
		local sourceID = info.sourceID
		local recipientID = info.recipientID
		if not sourceID then
			for unit in PitBull:IterateUnitFrames() do
				if UnitName(unit) == info.sourceName then
					sourceID = unit
				end
			end
			if not sourceID then
				return
			end
		end
		if not recipientID then
			for unit in PitBull:IterateUnitFrames() do
				if UnitName(unit) == info.recipientName then
					recipientID = unit
				end
			end
			if not recipientID then
				return
			end
		end
		local amount = info.amount
		if sourceID == recipientID then
			amount = amount / 2
		end
		for _,startframe in ipairs(relationships[sourceID]) do
			if startframe:IsShown() then
				for _,endframe in ipairs(relationships[recipientID]) do
					if startframe ~= endframe and endframe:IsShown() then
						self:MakeLine('h',startframe,endframe,amount)
					end
				end
			end
		end
	end
	
	function PitBull_InteractLines:OnDamage(info)
		if not info.sourceID and not info.recipientID then
			return
		end
		local sourceID = info.sourceID
		local recipientID = info.recipientID
		if not sourceID then
			for unit in PitBull:IterateUnitFrames() do
				if UnitName(unit) == info.sourceName then
					sourceID = unit
				end
			end
			if not sourceID then
				return
			end
		end
		if not recipientID then
			for unit in PitBull:IterateUnitFrames() do
				if UnitName(unit) == recipientName then
					recipientID = unit
				end
			end
			if not recipientID then
				return
			end
		end
		local amount = info.amount
		if sourceID == recipientID then
			amount = amount / 2
		end
		for _,startframe in ipairs(relationships[sourceID]) do
			if startframe:IsShown() then
				for _,endframe in ipairs(relationships[recipientID]) do
					if startframe ~= endframe and endframe:IsShown() then
						self:MakeLine('d',startframe,endframe,amount)
					end
				end
			end
		end
	end
	
	function PitBull_InteractLines:MakeLine(linetype,startframe,endframe,amount)
		--!!2.1 check, delete!
		local alphacheck
		if IsLoggedIn then
			alphacheck = 'GetEffectiveAlpha'
		else
			alphacheck = 'GetAlpha'
		end
		--
		if startframe[alphacheck](startframe) == 0 or endframe[alphacheck](endframe) == 0 or self.db.profile.groups[startframe.group].ignore or self.db.profile.groups[endframe.group].ignore then
			return
		end
		local line = getFrame()
		line.snd = startframe
		line.rcv = endframe
		if amount < self.db.profile.threshold then
			line.startalpha = self.db.profile.alpha * (amount / self.db.profile.threshold)
		else
			line.startalpha = self.db.profile.alpha
		end
		line.starttime = GetTime()
		line.endtime = line.starttime + self.db.profile.duration
		line.type = linetype
		positionLine(line)
	end
end
do
	local function clearrel()
		for k,v in pairs(relationships) do
			scrapTable(v)
			relationships[k] = nil
		end
	end
	PitBull_InteractLines.OnUpdateFrame = clearrel
	PitBull_InteractLines.OnPopulateUnitFrame = clearrel
	PitBull_InteractLines.OnClearUnitFrame = clearrel
end

do
	local nukeframes = {}
	local function rsrt(a,b)
		return a > b
	end
	function PitBull_InteractLines:UpdateLines()
		for k in pairs(nukeframes) do
			nukeframes[k] = nil
		end
		local time = GetTime()
		for k,v in ipairs(activelines) do
			if v.endtime <= time then
				nukeframes[#nukeframes+1] = k
			else
				v:SetAlpha(v.startalpha*((v.endtime-time)/self.db.profile.duration))
			end
		end
		table.sort(nukeframes,rsrt)
		for _,v in ipairs(nukeframes) do
			scrapFrame(v)
		end
	end
	function PitBull_InteractLines:OnClearUnitFrame(unit, frame)
		for k in pairs(nukeframes) do
			nukeframes[k] = nil
		end
		for k,v in ipairs(activelines) do
			if v.snd == frame or v.rcv == frame then
				nukeframes[#nukeframes+1] = k
			end
		end
		table.sort(nukeframes,rsrt)
		for _,v in ipairs(nukeframes) do
			scrapFrame(v)
		end
		for k,v in pairs(relationships) do
			scrapTable(v)
			relationships[k] = nil
		end
	end
end
-- global options
local function getAlpha()
	return self.db.profile.alpha
end
local function setAlpha(v)
	self.db.profile.alpha = v
end
local function getDuration()
	return self.db.profile.duration
end
local function setDuration(v)
	self.db.profile.duration = v
end
local function getHealColor()
	return unpack(self.db.profile.healcolor)
end
local function setHealColor(r,g,b)
	self.db.profile.healcolor = {r,g,b}
end
local function getDamageColor()
	return unpack(self.db.profile.damagecolor)
end
local function setDamageColor(r,g,b)
	self.db.profile.damagecolor = {r,g,b}
end
local function getThreshold()
	return self.db.profile.threshold
end
local function setThreshold(v)
	self.db.profile.threshold = v
end
PitBull.options.args.global.args.interactlines = {
	type = 'group',
	name = L["InteractLines"],
	desc = L["InteractLines"],
	args = {
		alpha = {
			type = 'range',
			name = L["Line alpha"],
			desc = L["Line alpha"],
			isPercent = true,
			min = 0,
			max = 1,
			step = 0.05,
			get = getAlpha,
			set = setAlpha,
		},
		duration = {
			type = 'range',
			name = L["Line duration"],
			desc = L["Line duration"],
			min = 0.5,
			max = 10,
			step = 0.5,
			get = getDuration,
			set = setDuration,
		},
		healcolor = {
			type = 'color',
			name = L["Heal color"],
			desc = L["Heal color"],
			get = getHealColor,
			set = setHealColor,
		},
		damagecolor = {
			type = 'color',
			name = L["Damage color"],
			desc = L["Damage color"],
			get = getDamageColor,
			set = setDamageColor,
		},
		threshold = {
			type = 'range',
			name = L["Amount threshold"],
			desc = L["Line fades if damage/heal amount is below this number"],
			min = 0,
			max = 5000,
			step = 250,
			get = getThreshold,
			set = setThreshold,
		},
	},
}
-- per group options
local function getEnabled(group)
	return not PitBull_InteractLines.db.profile.groups[group].ignore
end
local function setEnabled(group, value)
	PitBull_InteractLines.db.profile.groups[group].ignore = not value
end
PitBull_InteractLines:RegisterPitBullOptionsMethod(function(group)
	return {
		type = 'toggle',
		name = L["Enable InteractLines"],
		desc = L["Enable InteractLines"],
		get = getEnabled,
		set = setEnabled,
		passValue = group,
	}
end)
